=== requirements.txt ===
-r requirements-base.txt
cmakelint
types-openpyxl
types-PyYAML
openpyxl-stubs
openpyxl
json2html
ruamel.yaml
pandas
mypy
lxml
pycompliance
# used in utils/controleval_metrics.py
prometheus_client
