=== debian/changelog ===
scap-security-guide (0.1.71-1) unstable; urgency=medium

  * New upstream release.
  * Add python3-lxml as BD.
  * Update installed files.

 -- Håvard F. Aasen <havard.f.aasen@pfft.no>  Sun, 10 Dec 2023 13:02:51 +0100
