=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
#export DH_VERBOSE = 1

NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))

%:
	dh $@ --builddir=build

override_dh_auto_configure:
	dh_auto_configure -- \
		-DSSG_BASH_SCRIPTS_ENABLED=OFF \
		-DSSG_BATS_TESTS_ENABLED=OFF \
		-DSSG_JINJA2_CACHE_ENABLED=OFF \
		-DSSG_LINKCHECKER_VALIDATION_ENABLED=OFF \
		-DSSG_OVAL_SCHEMATRON_VALIDATION_ENABLED=OFF \
		-DSSG_SHELLCHECK_BASH_FIXES_VALIDATION_ENABLED=OFF

override_dh_auto_test:
	dh_auto_test -- ARGS="--output-on-failure --parallel $(NUMJOBS)"
