## scap-security-guide 0.1.73

=== debian/changelog ===
scap-security-guide (0.1.73-1) unstable; urgency=medium

  * New upstream release.
  * Update Standards-Version to 4.7.0, no changes needed.
  * Use wildcard when installing files.
  * Include openEuler 22.03.

 -- Håvard F. Aasen <havard.f.aasen@pfft.no>  Sun, 19 May 2024 10:02:34 +0200
