=== debian/control ===
--- 
+++ 
@@ -13,7 +13,7 @@
                python3-setuptools,
                python3-yaml,
                xsltproc,
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 Rules-Requires-Root: no
 Homepage: https://www.open-scap.org/security-policies/scap-security-guide
 Vcs-Git: https://salsa.debian.org/pkg-security-team/scap-security-guide.git
@@ -129,6 +129,7 @@
    - Apple macOS 10.15
    - Fedora
    - OpenEmbedded
+   - openEuler 22.03
    - openSUSE
    - Oracle Linux 7
    - Oracle Linux 8
