=== debian/changelog ===
scap-security-guide (0.1.74-1) unstable; urgency=medium

  * New upstream release.
  * Patch from upstream to fix validation with OpenSCAP 1.4.
    Closes: #1086382
  * Update installed products and package descriptions.

 -- Håvard F. Aasen <havard.f.aasen@pfft.no>  Sat, 02 Nov 2024 19:39:34 +0100
