=== debian/control ===
--- 
+++ 
@@ -54,7 +54,6 @@
  as official policies.
  .
  This package include SCAP guides for:
-   - Debian 10
    - Debian 11
    - Debian 12
 
@@ -124,6 +123,7 @@
  This package include SCAP guides for:
    - Alibaba Cloud Linux 2
    - Alibaba Cloud Linux 3
+   - Amazon Linux 2023
    - Anolis OS 8
    - Anolis OS 23
    - Apple macOS 10.15
@@ -134,12 +134,13 @@
    - Oracle Linux 7
    - Oracle Linux 8
    - Oracle Linux 9
-   - Red Hat Enterprise Linux 7
    - Red Hat Enterprise Linux 8
    - Red Hat Enterprise Linux 9
+   - Red Hat Enterprise Linux 10
    - Red Hat Enterprise Linux CoreOS 4
    - Red Hat OpenShift Container Platform 4
    - Red Hat Virtualization 4
    - SUSE Linux Enterprise 12
    - SUSE Linux Enterprise 15
+   - SUSE Linux Enterprise Micro 5
    - UnionTech OS Server 20
